#!python2
#coding: utf-8

# Ver.0.2 2018.11.10

from time import sleep
import os
import socket
import urllib2
import clipboard
import notification
import markdown2
import webbrowser

FLASHAIR_IP = "192.168.0.1"
WAIT_LIMIT = 120
MARKDOWN = True
FILE_NAME = "0PREV.TXT"
DIR = "FlashAir"

# ------

FPATH = "%s/%s" % (DIR, os.path.splitext(FILE_NAME)[0] + ".html")

def init():
	if not os.path.exists(DIR):
		os.mkdir(DIR)

def mes(m, success=False):
	print(m)
	url = "http://%s/%s" % (FLASHAIR_IP, FILE_NAME)
	if (success):
		notification.schedule(m, 0, "default", url)
	else:
		notification.schedule(m, 0, "default")

def is_flashair_online():
    try:
        socket.setdefaulttimeout(1)
        req = urllib2.Request("http://%s" % FLASHAIR_IP)
        response = urllib2.urlopen(req)
        return True
    except IOError:
        return False

def sandbox_path(p):
    return ('file://' + os.path.realpath(p)).replace(" ", "%20")

def pomera_preview():
    try:
        url = "http://%s/%s" % (FLASHAIR_IP, FILE_NAME)
        r = urllib2.urlopen(url)
        f = open(FPATH, "w")
        if (MARKDOWN):
        	t = markdown2.markdown(r.read().decode("shift_jis").replace("\r\n", "\n")).replace("\n", "\r")
        else:
        	t = r.read().decode("shift_jis").replace("\r\n", "\r")
        t = """
<!DOCTYPE html>
<html lang="ja">
<head>
<meta charset="utf-8">
<meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">
<title>pomera_preview</title>
<link rel="stylesheet" href="semantic.min.css">
<link rel="stylesheet" href="pomera.css">
<script src="semantic.min.js"></script>
<script src="jquery-3.3.1.min.js"></script>
<script src="pomera.js"></script>
</head>
<body>
%s
</body>
</html>
""" % t
        f.writelines(t)
        f.close()
        url = sandbox_path(FPATH)
        webbrowser.open(url)
        #mes("pomera_preview done.", True)
    except IOError:
    	mes("pomera_preview failed.")

def main():
    init()
    for i in range(WAIT_LIMIT):
        if (is_flashair_online()):
            try:
                pomera_preview()
                exit()
            except IOError:
            	mes("pomera_preview failed. retry.")
        else:
            f = "wait %03d/%03d" % (i, WAIT_LIMIT)
            print(f)
        sleep(1)
    mes("connect failed.")

main()
